Unity causing massive memory leak when hovering over the quicklists

Bug #604777 reported by Omer Akram on 2010-07-12
96
This bug affects 15 people
Affects Status Importance Assigned to Milestone
CluTK
Critical
Jay Taoko
Unity
Fix Released
Critical
Jay Taoko
clutk (Ubuntu)
High
Canonical Desktop Experience Team
Maverick
High
Canonical Desktop Experience Team
unity (Ubuntu)
Undecided
Unassigned
Maverick
Undecided
Unassigned

Bug Description

Binary package hint: unity

Either in gnome session or unity session, with or without mutter. after the use of a few minutes hovering over the quicklists cause a massive memory leak. The problem does not happen if unity is not started as I used gnome session with mutter or compiz without any problem for many hours.

ProblemType: Bug
DistroRelease: Ubuntu 10.10
Package: unity 0.2.14-0ubuntu1
ProcVersionSignature: Ubuntu 2.6.35-7.12-generic 2.6.35-rc4
Uname: Linux 2.6.35-7-generic i686
Architecture: i386
Date: Tue Jul 13 00:51:05 2010
InstallationMedia: Ubuntu-Netbook 10.10 "Maverick Meerkat" - Alpha i386 (20100711)
ProcEnviron:
 LANG=en_US.utf8
 SHELL=/bin/bash
SourcePackage: unity

Omer Akram (om26er) wrote :
Omer Akram (om26er) wrote :

after the video ended. I quitted unity with and the swap usage directly fell to 121mb

Gord Allott (gordallott) on 2010-07-12
Changed in unity:
importance: Undecided → Critical
importance: Critical → High
assignee: nobody → Mirco Müller (macslow)
Gord Allott (gordallott) on 2010-07-12
Changed in unity:
status: New → Triaged
milestone: none → 2010-07-15
Omer Akram (om26er) wrote :

if I don't use any swap space unity session is only usable for 15mins. if there is swap then after the usage of a 45min swap becomes full and system becomes non responsive and at last have to kill X.

Omer Akram (om26er) wrote :

om26er@maverick:~$ cat /sys/kernel/debug/dri/0/gem_objects
722 objects
539701248 object bytes
3 pinned
6782976 pin bytes
96858112 gtt bytes
260308992 gtt total

Mirco Müller (macslow) on 2010-07-15
Changed in unity:
status: Triaged → In Progress
Neil J. Patel (njpatel) on 2010-07-16
Changed in unity:
milestone: 2010-07-15 → 2010-07-22
importance: High → Critical
Omer Akram (om26er) wrote :

happens on Nvidia too but in that case instead of virtual memory, ram usage keeps on increasing.

Mirco Müller (macslow) wrote :

I've some thorough valgrind-log from running on an intel GMA X3100. Which shows ~40 MBytes of "still reachable" and "possibly lost" memory due to the dri-driver-part and clutter. Before continuing I rather want to wait until the CtkMenuExpandable landed in unity trunk, as it heavily affects the quicklist-rendering. Thus I want to avoid having to debug this twice.

Mirco Müller (macslow) wrote :

For reference the command to capture this was:

valgrind --leak-check=full --leak-resolution=high --show-reachable=yes mutter --mutter-plugins=/home/mirco/src/unity-team/unity/targets/mutter/.libs/libunity-mutter.so --replace &>/tmp/mem-leaks-1.log

David Barth (dbarth) on 2010-07-26
Changed in unity:
milestone: 2010-07-22 → 2010-07-29
David Barth (dbarth) on 2010-08-03
Changed in unity:
assignee: Mirco Müller (macslow) → Jason Smith (jassmith)
milestone: 2010-07-29 → 2010-08-12
Changed in unity:
milestone: 2010-08-12 → 2010-08-19
Neil J. Patel (njpatel) on 2010-08-20
Changed in unity:
milestone: 2010-08-19 → 2010-08-26

Just for reference: The tool 'xrestop' can be used to inspect the
resource consumption of x11 clients

papukaija (papukaija) wrote :

This bug is affecting 3 people.

Changed in unity (Ubuntu):
status: New → Confirmed
Omer Akram (om26er) on 2010-08-26
Changed in unity (Ubuntu):
importance: Undecided → High
status: Confirmed → Triaged
Timo Wiren (timo-wiren) wrote :

This bug affects me on Acer Aspire One (Intel 945GME) on Ubuntu Netbook pre-Beta .iso downloaded 2010-09-01. When hovering over the quicklist the whole system becomes unresponsive for a while.

David Barth (dbarth) on 2010-09-02
Changed in unity:
assignee: Jason Smith (jassmith) → Neil J. Patel (njpatel)
milestone: 2010-08-26 → 2010-09-09
Didier Roche (didrocks) on 2010-09-02
Changed in unity (Ubuntu):
milestone: none → ubuntu-10.10
Didier Roche (didrocks) on 2010-09-03
Changed in unity (Ubuntu):
assignee: nobody → Canonical Desktop Experience Team (canonical-dx-team)
owise1 (o-wise-1) wrote :

This bug affects me as well

On eeePC 701 with 4G HD and 512M ram. Installed beta version of netbook edition with default install. Found that running pointer over quicklists has swap usage climbing till it hits 100% without have any other applications open other than system monitor. This renders system unusable. Use of RAM remains at around 25%

Have re-installed without any swap - has large amount of disk activity on first start that appears to be related to quicklists being populated?? Still very sluggish but just useable. Logging in to a normal desktop edition make this little PC much more responsive.

Oleksandr Pr (235-inmind) wrote :

I have the same problem on eeePC 1005PE after updating to ubuntu 10.10. Use of RAM ~20% while system runs out of swap and mutter dies in pain. All you need is to roll with a mouse over sidebar on left (quicklists). System is totally unusable, however looks like unity 2D version does not have this problem.

video card:
00:02.0 VGA compatible controller: Intel Corporation N10 Family Integrated Graphics Controller (prog-if 00 [VGA controller])

mutter errors while you are just rolling over icons on a quicklist bar (see attachment for a full mutter log) :

(mutter:3660): libunity-private-WARNING **: quicklist-controller.vala:165: state change called on menu when menu does not exist

(mutter:3660): Clutter-WARNING **: The actor 'UnityLauncherQuicklistMenu' is currently inside an allocation cycle; calling clutter_actor_queue_relayout() is not recommended

Mirco Müller (macslow) wrote :

I've attached a second valgrind log-file created using current (7.9.2010) trunk versions of clutk and unity. I ran unity as a mutter plugin and hovered a couple of seconds over different launcher-icons and also opened up a few quicklists. There are still ~5100 unresolved symbols, but that's because there are no -dbg packages for libraries like libexpat, libfreetype, mutter, libdbus, liborbit etc. This is done on a laptop with an intel i965 chipset and the GMA X3100 GPU.

A thorough analysis of the big memory-leaking culprits I still have to do.

Just off the bat it looks like the interesting parts of the second valgrind log is in the very bottom. The last many calls are marking several megs as "possibly lost" in each chunk of the log. Just a hint for would-be-prying eyes :-)

David Barth (dbarth) wrote :

New valgrind log, as run on a GMA945. I just hovered a bit over the launcher to get some tooltips to show up.

Note: This bug is very likely related to bug #621690: "Places are slow render (regression)" - although it's very hard to tell if it's really a dupe at this point.

David Barth (dbarth) wrote :

The leak has been partially improved by Jay's first patch, and Mikkel (for the places), but there are still more leaks identified.

Changed in unity:
milestone: 2010-09-09 → 2010-09-16
Neil J. Patel (njpatel) on 2010-09-16
Changed in unity:
assignee: Neil J. Patel (njpatel) → Jay Taoko (jaytaoko)
milestone: 2010-09-16 → 2010-09-22
status: In Progress → Fix Released
Changed in clutk:
assignee: nobody → Jay Taoko (jaytaoko)
importance: Undecided → Critical
status: New → Fix Released
Didier Roche (didrocks) on 2010-09-17
affects: unity (Ubuntu Maverick) → clutk (Ubuntu Maverick)
Didier Roche (didrocks) on 2010-09-17
Changed in unity (Ubuntu Maverick):
status: New → Triaged
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package clutk - 0.3.58-0ubuntu1

---------------
clutk (0.3.58-0ubuntu1) maverick; urgency=low

  * New upstream release:
    - fix massive mem leaks in unity (LP: #604777)
  * debian/control:
    - bump the libclutter-1.0-dev build-dep to ensure having the right
      distro patch.
 -- Didier Roche <email address hidden> Fri, 17 Sep 2010 13:52:28 +0200

Changed in clutk (Ubuntu Maverick):
status: Triaged → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unity - 0.2.40-0ubuntu1

---------------
unity (0.2.40-0ubuntu1) maverick; urgency=low

  * New upstream release:
    - Fix inactive menus accessible (LP: #604505)
    - Fix some more memory leaks (LP: #604777, #621690, #628144)
    - Fix weird behaviors of quicklist (LP: #617339)
    - Provide an "open this folder" button (LP: #633201)
    - Hidden menu causing gap (LP: #600191)
    - Cannot go fullscreen for flash videos (LP: #631381)
    - Can't access menu items from the keyboard (LP: #636728)
    - Don't register for MDRAGs since they aren't used (LP: #632613)
    - Don't run indicator on special launchers (LP: #627488)
    - Center arrows position in folded launcher tiles (LP: #633084)
    - Launcher icons first appear as white upon login (LP: #601093)
    - Removes jittering when rubber band is in use on the launcher (LP: #632991)
    - Mutter restarts on closing almost any application (LP: #634701)
    - Can't launch apps like synaptic with root privileges from launch bar
      (LP: #599298)
    - Launcher tile dragging shouldn't be masked (LP: #631443)
    - Fix Carousel-ed icons have distorted perspective (LP: #607515)
    - Use no longer sync call (LP: #620011)
  * update debian/libunity0.symbols
 -- Didier Roche <email address hidden> Fri, 17 Sep 2010 14:02:54 +0200

Changed in unity (Ubuntu Maverick):
status: Triaged → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers